/*
   Feather Huzzah, compiled in Arduino 1.8.1
   Buttons on pins 4 and 5
   Buttons are pull-down to ground


plugsocket - starting from pointy end: 
pin4/blue -pin5/green- Red (Led?)- copper (gnd?)

   
   Pot on A0
   Neopixel leftstrips on 14 and 15
   LED on 0

   Version 2019-02-08



//connector on 



*/



#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif

#define PIN 14
#define PIN2 15

// Parameter 1 = number of pixels in leftstrip
// Parameter 2 = Arduino pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
Adafruit_NeoPixel leftstrip = Adafruit_NeoPixel(27, PIN, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel rightstrip = Adafruit_NeoPixel(27, PIN2, NEO_GRB + NEO_KHZ800);

// IMPORTANT: To reduce NeoPixel burnout risk, add 1000 uF capacitor across
// pixel power leads, add 300 - 500 Ohm resistor on first pixel's data input
// and minimize distance between Arduino and first pixel.  Avoid connecting
// on a live circuit...if you must, connect GND first.


byte blinkMode = 0;
byte previousBlinkMode = 0;


int button4Toggle = 0;
int button5Toggle = 0;


void setup() {
  // This is for Trinket 5V 16MHz, you can remove these three lines if you are not using a Trinket
#if defined (__AVR_ATtiny85__)
  if (F_CPU == 16000000) clock_prescale_set(clock_div_1);
#endif
  delay(100);
  // End of trinket special code
  pinMode(PIN, OUTPUT);
  pinMode(PIN2, OUTPUT);
  pinMode(13, OUTPUT);
  blinkMode = 1;
  indicateBlinkMode();
  pinMode(0, OUTPUT);
  pinMode(4, INPUT_PULLUP); //Pushbutton 1
  pinMode(5, INPUT_PULLUP); //Pushbutton 2


  leftstrip.begin();
  leftstrip.show(); // Initialize all pixels to 'off'
  rightstrip.begin();
  rightstrip.show(); // Initialize all pixels to 'off'
  delay(1); //delays needed to keep ESP2866 stable, not needed for other boards
}






void loop() {
  // Some example procedures showing how to display to the pixels:
  //  colorWipe(leftstrip.Color(255, 0, 0), 50); // Red
  // colorWipe(leftstrip.Color(0, 255, 0), 50); // Green
  //colorWipe(leftstrip.Color(0, 0, 255), 50); // Blue
  delay(1); //delays needed to keep ESP2866 stable, not needed for other boards
  if (analogRead(A0) < 200) {
    //this mode is traffic indicator lights
    blinkMode = 1;
    indicateBlinkMode(); // this function makes the LED blink to indicate the current mode

    colorSet(0);
    digitalWrite(0, LOW);
    //main program option: push buttons for blinkers
    if (digitalRead(5) == LOW ) {
      yellowBlink(leftstrip, 800);
    }

    if (digitalRead(4) == LOW) {
      yellowBlink(rightstrip, 800);
    }
  }

  if (analogRead(A0) > 200 && analogRead(A0) < 412 ) { //This is red lights mode
    blinkMode = 2;
    indicateBlinkMode();

    colorSet(0);
    digitalWrite(0, LOW);
    updateToggles();

    if (button4Toggle == 1) {

      digitalWrite(13, HIGH);digitalWrite(0, HIGH);
      delay(5);
      digitalWrite(13, LOW);digitalWrite(0, LOW);
      colorWipeRed( 150);

      digitalWrite(0, LOW);
      digitalWrite(13, LOW);
    }


    if (button5Toggle == 1) {
      digitalWrite(13, HIGH);digitalWrite(0, HIGH);
      delay(5);
      digitalWrite(13, LOW);digitalWrite(0, LOW);
      softGlowRed(40);

    }
  }



  if (analogRead(A0) > 812) {
    //This is all-white LEDS on right button or 1 chasing LED on button 5
    blinkMode = 4;
    indicateBlinkMode();
    if (digitalRead(4) == LOW) {

      digitalWrite(13, HIGH);digitalWrite(0, HIGH);
      delay(100);
      digitalWrite(13, LOW);digitalWrite(0, LOW);
      colorWipe2( 150);

      digitalWrite(0, LOW);
      digitalWrite(13, LOW);
    }
    if (digitalRead(5) == LOW) {
      softGlow(40);

    }
  }

  if (analogRead(A0) > 412 && analogRead(A0) < 810) {
    blinkMode = 3;
    indicateBlinkMode();
    if (digitalRead(4) == LOW) {
      digitalWrite(13, HIGH);digitalWrite(0, HIGH);
      delay(100);
      digitalWrite(13, LOW);digitalWrite(0, LOW);
      delay(100);
      rainbowCycle(50);
      //  theaterChase(leftstrip.Color(127, 127, 127), 50); // White
      digitalWrite(0, LOW);
    }
  }






}

void indicateBlinkMode() {
  //this function blinks the LED when you turn the potmeter to select a different mode.
  // The LED blinks x times where x is the number of the blinkMode

  if (blinkMode != previousBlinkMode) {
    for (int k = 0; k <= blinkMode; k++) {
      digitalWrite(13, HIGH);digitalWrite(0, HIGH);
      delay(150);
      digitalWrite(13, LOW);digitalWrite(0, LOW);
      delay(150);


    }

  }
  previousBlinkMode = blinkMode; //this makes sure the LED only blinks when whe change mode, not every loop when the function is called

}

void updateToggles() {   //this function reads the state of the buttons and changes the togglevalues button4Toggle and button5Toggle when the buttons are pressed
  //this allows us to turn stuff on and off with short presses of the buttons

  if (digitalRead(4) == LOW) {
    if (button4Toggle == 0) {
      button4Toggle = 1;
    }
    else {
      button4Toggle = 0;
    }
  }
  if (digitalRead(5) == LOW) {
    if (button5Toggle == 0) {
      button5Toggle = 1;
    }
    else {
      button5Toggle = 0;
    }
  }


}
